from Headers.Constants import *
from numpy import log #@Q: why not "from math import log" ?

# 3.5 PN frequency coefficients - circular non-spinning

NSF1 = 0.2764136904761905
NSF2 = 0.34375
NSF3 = -0.3
NSF4 = 0.1283744414106789
NSF5 = 0.2207922557043651
NSF6 = 0.18115234375
NSF7 = -0.3594215029761905
NSF8 = 0.05078125
NSF9 = -2.499258364444952
NSF10 = 0.265
NSF11 = 0.3821428571428571
NSF12 = 6.079587981333868
NSF13 = -0.22021484375
NSF14 = -0.01684624808175223
NSF15 = 0.1333307336877894
NSF16 = 0.3821428571428571
NSF17 = -0.4348505505989288
NSF18 = -0.3788636222718254
NSF19 = 0.1098780071924603


# 3.5 PN phase coefficients - circular non-spinning

NSP1 = 0.4606894841269841       # 3715/8064
NSP2 = 0.5729166666666667       # 55/96
NSP3 = -0.75                    # -3/4
NSP4 = 0.6418722070533943       # 9275495/14450688
NSP5 = 1.103961278521825        # 284875/258048
NSP6 = 0.90576171875            # 1855/2048
NSP7 = 1.797107514880952        # 38645/21504
NSP8 = -0.25390625              # -65/256
NSP9 = 14.40700610793905        # 831032450749357/57682522275840
NSP10 = -1.325                  # -53/40
NSP11 = -30.39793990666934      # -126510089885/4161798144
NSP12 = 1.10107421875           # 2255/2048
NSP13 = -1.910714285714286      # -107/56
NSP14 = 0.08423124040876116     # 154565/1835008
NSP15 = -0.6666536684389468     # -1179625/1769472
NSP16 = -1.910714285714286      # ?
NSP17 = 1.087126376497322       # 188516689/173408256
NSP18 = 0.9471590556795635      # 488825/516096
NSP19 = -0.2746950179811508     # -141769/516096




# 2 PN t(f) coefficients

tf1 = (5.0/256)
tf2 = (743.0/252.0)
tf3 = (11.0/3.0)
tf4 = (-32.0/5.0)
tf5 = (3058673.0/508032.0)
tf6 = (5429.0/504.0)
tf7 = (617.0/72.0)
tf8 = (13.0/3.0)
tf9 = (-7729.0/252.0)
tf10 = (6848.0/105.0)
tf11 = (-10052469856691.0/23471078400.0)
tf12 = (128.0/3.0)
tf13 = (3147553127.0/3048192.0)
tf14 = (-451.0/12.0)
tf15 = (-15211.0/1728.0)
tf16 = (25565.0/12960)
tf17 = (14809.0/378.0)
tf18 = (-75703.0/756.0)
tf19 = (-15419335.0/127008.0)




# 3.5 PN Taylorf2 coefficients

Tf2_1 = (3.0/128.0)
Tf2_2 = (3715.0/756.0)
Tf2_3 = (55.0/9.0)
Tf2_4 = (-16.0)
Tf2_5 = (15293365.0/508032.0)
Tf2_6 = (27145.0/504.0)
Tf2_7 = (3085.0/72.0)
Tf2_8 = (38645.0/756.0)
Tf2_9 = (-65.0/9.0)
Tf2_10 = (11583231236531.0/4694215680.0)
Tf2_11 = (-640.0/3.0)
Tf2_12 = (-6848.0/21.0)
Tf2_13 = (2255.0/12.0)
Tf2_14 = (-15737765635.0/3048192.0)
Tf2_15 = (76055.0/1728.0)
Tf2_16 = (-127825.0/1296.0)
Tf2_17 = (77096675.0/254016.0)
Tf2_18 = (378515.0/1512.0)
Tf2_19 = (-74045.0/756.0)




# "3.5 PN Taylorf2-like" coefficients for the derivateve of the phase with respect to chirp mass

Tf2_0_dMc = (5.0/128.0)*PI*GEOM
Tf2_2_dMc = -(55.0/6.0)
Tf2_3_dMc = (-8.0)*PI
Tf2_4_dMc = (15293365.0/508032.0)
Tf2_5_dMc = -(27145.0/1008.0)
Tf2_6_dMc = -(3085.0/36.0)
Tf2_7_dMc = (38645.0/252.0)*PI
Tf2_8_dMc = (-65.0/6.0)*PI
Tf2_9_1_dMc = (11583231236531.0/2347107840.0)
Tf2_9_2_dMc = - (1280.0/3.0)*PI*PI
Tf2_9_3_dMc = - (13696.0/21.0)*EULER
Tf2_9_4_dMc = - (13696.0/21.0)*log(4)
Tf2_10_dMc = (-3424.0/21.0)
Tf2_11_1_dMc = (-15737765635.0/6096384.0)
Tf2_11_2_dMc = (2255.0/24.0)*PI*PI
Tf2_12_dMc = -(76055.0/1728.0)
Tf2_13_dMc = (639125.0/2592.0)
Tf2_14_dMc = (385483375.0/508032.0)*PI
Tf2_15_dMc = (378515.0/1512.0)*PI
Tf2_16_dMc = (74045.0/1512.0)*PI






# "3.5 PN Taylorf2-like" coefficients for the derivateve of the phase with respect to reduced mass

Tf2_0_dMu = (3.0/256.0)*(PI*GEOM)
Tf2_1_dMu = -(3715.0/378.0)
Tf2_2_dMu = (55.0/3.0)
Tf2_3_dMu = 48.0*PI
Tf2_4_dMu = -(15293365.0/127008.0)
Tf2_5_dMu = (27145.0/504.0)
Tf2_6_dMu = (3085.0/12.0)
Tf2_7_dMu = -(77290.0/189.0)*PI
Tf2_8_dMu = (65.0/3.0)*PI
Tf2_9_1_dMu = -(11583231236531.0/782369280.0)
Tf2_9_2_dMu = 1280.0*PI*PI
Tf2_9_3_dMu = (13696.0/7.0)*EULER
Tf2_9_4_dMu = (13696.0/7.0)*log(4)
Tf2_10_dMu = (6848.0/21.0)
Tf2_11_1_dMu = (15737765635.0/3048192.0)
Tf2_11_2_dMu = -(2255.0/12.0)*PI*PI
Tf2_12_dMu = (76055.0/432.0)
Tf2_13_dMu = -(127825.0/144.0)
Tf2_14_dMu = -(77096675.0/36288.0)*PI
Tf2_15_dMu = -(378515.0/756.0)*PI
Tf2_16_dMu = -(74045.0/252.0)*PI
